package org.wfc.omada.api.sitesetting.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import java.util.Objects;

/**
 * VirtualWanIpv4SettingConfigOpenApiVO
 */
@ApiModel(description = "VirtualWanIpv4SettingConfigOpenApiVO")
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:32:19.054+08:00[Asia/Shanghai]")

public class VirtualWanIpv4SettingConfigOpenApiVo   {
  @JsonProperty("proto")
  private String proto;

  @JsonProperty("vlanId")
  private Integer vlanId;

  @JsonProperty("vlanPriority")
  private Integer vlanPriority;

  @JsonProperty("qosTagEnable")
  private Boolean qosTagEnable;

  @JsonProperty("qosTag")
  private Integer qosTag;

  @JsonProperty("ipv4Static")
  private Object ipv4Static;

  @JsonProperty("ipv4Dhcp")
  private Object ipv4Dhcp;

  @JsonProperty("ipv4Pppoe")
  private Object ipv4Pppoe;

  @JsonProperty("ipv4Pppoa")
  private VirtualWanIpv4PppoaOpenApiVo ipv4Pppoa;

  @JsonProperty("ipv4Ipoa")
  private VirtualWanIpv4IpoaOpenApiVo ipv4Ipoa;

  public VirtualWanIpv4SettingConfigOpenApiVo proto(String proto) {
    this.proto = proto;
    return this;
  }

  /**
   * Virtual WAN IPv4 proto type, use static, dhcp, pppoe.
   * @return proto
  */
  @ApiModelProperty(required = true, value = "Virtual WAN IPv4 proto type, use static, dhcp, pppoe.")
  @NotNull


  public String getProto() {
    return proto;
  }

  public void setProto(String proto) {
    this.proto = proto;
  }

  public VirtualWanIpv4SettingConfigOpenApiVo vlanId(Integer vlanId) {
    this.vlanId = vlanId;
    return this;
  }

  /**
   * Vlan ID. Parameter [vlanId] should between 1 and 4094.
   * @return vlanId
  */
  @ApiModelProperty(required = true, value = "Vlan ID. Parameter [vlanId] should between 1 and 4094.")
  @NotNull


  public Integer getVlanId() {
    return vlanId;
  }

  public void setVlanId(Integer vlanId) {
    this.vlanId = vlanId;
  }

  public VirtualWanIpv4SettingConfigOpenApiVo vlanPriority(Integer vlanPriority) {
    this.vlanPriority = vlanPriority;
    return this;
  }

  /**
   * Vlan Priority. It takes effect when [vlanId] is not 0, and it should be within the range of 0–7.
   * @return vlanPriority
  */
  @ApiModelProperty(value = "Vlan Priority. It takes effect when [vlanId] is not 0, and it should be within the range of 0–7.")


  public Integer getVlanPriority() {
    return vlanPriority;
  }

  public void setVlanPriority(Integer vlanPriority) {
    this.vlanPriority = vlanPriority;
  }

  public VirtualWanIpv4SettingConfigOpenApiVo qosTagEnable(Boolean qosTagEnable) {
    this.qosTagEnable = qosTagEnable;
    return this;
  }

  /**
   * Whether to enable 802.1Q Tag.
   * @return qosTagEnable
  */
  @ApiModelProperty(value = "Whether to enable 802.1Q Tag.")


  public Boolean getQosTagEnable() {
    return qosTagEnable;
  }

  public void setQosTagEnable(Boolean qosTagEnable) {
    this.qosTagEnable = qosTagEnable;
  }

  public VirtualWanIpv4SettingConfigOpenApiVo qosTag(Integer qosTag) {
    this.qosTag = qosTag;
    return this;
  }

  /**
   * Qos Tag. Parameter [qosTag] should between 0 and 7.
   * @return qosTag
  */
  @ApiModelProperty(value = "Qos Tag. Parameter [qosTag] should between 0 and 7.")


  public Integer getQosTag() {
    return qosTag;
  }

  public void setQosTag(Integer qosTag) {
    this.qosTag = qosTag;
  }

  public VirtualWanIpv4SettingConfigOpenApiVo ipv4Static(Object ipv4Static) {
    this.ipv4Static = ipv4Static;
    return this;
  }

  /**
   * Get ipv4Static
   * @return ipv4Static
  */
  @ApiModelProperty(value = "")

  @Valid

  public Object getIpv4Static() {
    return ipv4Static;
  }

  public void setIpv4Static(Object ipv4Static) {
    this.ipv4Static = ipv4Static;
  }

  public VirtualWanIpv4SettingConfigOpenApiVo ipv4Dhcp(Object ipv4Dhcp) {
    this.ipv4Dhcp = ipv4Dhcp;
    return this;
  }

  /**
   * Get ipv4Dhcp
   * @return ipv4Dhcp
  */
  @ApiModelProperty(value = "")

  @Valid

  public Object getIpv4Dhcp() {
    return ipv4Dhcp;
  }

  public void setIpv4Dhcp(Object ipv4Dhcp) {
    this.ipv4Dhcp = ipv4Dhcp;
  }

  public VirtualWanIpv4SettingConfigOpenApiVo ipv4Pppoe(Object ipv4Pppoe) {
    this.ipv4Pppoe = ipv4Pppoe;
    return this;
  }

  /**
   * Get ipv4Pppoe
   * @return ipv4Pppoe
  */
  @ApiModelProperty(value = "")

  @Valid

  public Object getIpv4Pppoe() {
    return ipv4Pppoe;
  }

  public void setIpv4Pppoe(Object ipv4Pppoe) {
    this.ipv4Pppoe = ipv4Pppoe;
  }

  public VirtualWanIpv4SettingConfigOpenApiVo ipv4Pppoa(VirtualWanIpv4PppoaOpenApiVo ipv4Pppoa) {
    this.ipv4Pppoa = ipv4Pppoa;
    return this;
  }

  /**
   * Get ipv4Pppoa
   * @return ipv4Pppoa
  */
  @ApiModelProperty(value = "")

  @Valid

  public VirtualWanIpv4PppoaOpenApiVo getIpv4Pppoa() {
    return ipv4Pppoa;
  }

  public void setIpv4Pppoa(VirtualWanIpv4PppoaOpenApiVo ipv4Pppoa) {
    this.ipv4Pppoa = ipv4Pppoa;
  }

  public VirtualWanIpv4SettingConfigOpenApiVo ipv4Ipoa(VirtualWanIpv4IpoaOpenApiVo ipv4Ipoa) {
    this.ipv4Ipoa = ipv4Ipoa;
    return this;
  }

  /**
   * Get ipv4Ipoa
   * @return ipv4Ipoa
  */
  @ApiModelProperty(value = "")

  @Valid

  public VirtualWanIpv4IpoaOpenApiVo getIpv4Ipoa() {
    return ipv4Ipoa;
  }

  public void setIpv4Ipoa(VirtualWanIpv4IpoaOpenApiVo ipv4Ipoa) {
    this.ipv4Ipoa = ipv4Ipoa;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    VirtualWanIpv4SettingConfigOpenApiVo virtualWanIpv4SettingConfigOpenApiVo = (VirtualWanIpv4SettingConfigOpenApiVo) o;
    return Objects.equals(this.proto, virtualWanIpv4SettingConfigOpenApiVo.proto) &&
        Objects.equals(this.vlanId, virtualWanIpv4SettingConfigOpenApiVo.vlanId) &&
        Objects.equals(this.vlanPriority, virtualWanIpv4SettingConfigOpenApiVo.vlanPriority) &&
        Objects.equals(this.qosTagEnable, virtualWanIpv4SettingConfigOpenApiVo.qosTagEnable) &&
        Objects.equals(this.qosTag, virtualWanIpv4SettingConfigOpenApiVo.qosTag) &&
        Objects.equals(this.ipv4Static, virtualWanIpv4SettingConfigOpenApiVo.ipv4Static) &&
        Objects.equals(this.ipv4Dhcp, virtualWanIpv4SettingConfigOpenApiVo.ipv4Dhcp) &&
        Objects.equals(this.ipv4Pppoe, virtualWanIpv4SettingConfigOpenApiVo.ipv4Pppoe) &&
        Objects.equals(this.ipv4Pppoa, virtualWanIpv4SettingConfigOpenApiVo.ipv4Pppoa) &&
        Objects.equals(this.ipv4Ipoa, virtualWanIpv4SettingConfigOpenApiVo.ipv4Ipoa);
  }

  @Override
  public int hashCode() {
    return Objects.hash(proto, vlanId, vlanPriority, qosTagEnable, qosTag, ipv4Static, ipv4Dhcp, ipv4Pppoe, ipv4Pppoa, ipv4Ipoa);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class VirtualWanIpv4SettingConfigOpenApiVo {\n");
    
    sb.append("    proto: ").append(toIndentedString(proto)).append("\n");
    sb.append("    vlanId: ").append(toIndentedString(vlanId)).append("\n");
    sb.append("    vlanPriority: ").append(toIndentedString(vlanPriority)).append("\n");
    sb.append("    qosTagEnable: ").append(toIndentedString(qosTagEnable)).append("\n");
    sb.append("    qosTag: ").append(toIndentedString(qosTag)).append("\n");
    sb.append("    ipv4Static: ").append(toIndentedString(ipv4Static)).append("\n");
    sb.append("    ipv4Dhcp: ").append(toIndentedString(ipv4Dhcp)).append("\n");
    sb.append("    ipv4Pppoe: ").append(toIndentedString(ipv4Pppoe)).append("\n");
    sb.append("    ipv4Pppoa: ").append(toIndentedString(ipv4Pppoa)).append("\n");
    sb.append("    ipv4Ipoa: ").append(toIndentedString(ipv4Ipoa)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

